# Adaptive Notch Filter

# FOO_M => MULTIPLY( A * 2.0 )
# FOO_A => ADD( A + B )
# FOO_D => DELAY( DLY( A ) )
# FOO_X => Signal Modulation( A * B )

#--------------------------------------
# CONSTANT
MEW   = 0.0003
MEW_W = 0.0003

FIRST_ALPHA = 0.999
ALPHA_DELAY = DLY( FIRST_ALPHA )
ALPHA_FIRST_ONLY = FIRST_ALPHA - ALPHA_DELAY

FIRST_BETA = -0.999
BETA_DELAY = DLY( FIRST_BETA )
BETA_FIRST_ONLY = FIRST_BETA - BETA_DELAY

#--------------------------------------
# ALL
MAIN_IN = INPUT

# G(z) side
ALL_G_X1 = MAIN_OUT_H_N * G_OUT
ALL_G_M1 = ALL_G_X1 * ( - MEW )
ALL_G_A1 = ALL_G_M1 + ALL_G_D1 + BETA_FIRST_ONLY
ALL_G_D1 = DLY( ALL_G_A1 )
ALL_BETA_PRE = DLY( ALL_G_A1 )
ALL_BETA = ALL_BETA_PRE + BETA_FIRST_ONLY

# FW(z) side
ALL_FW_X1 = MAIN_OUT_V * ( - FW_OUT )
ALL_FW_M1 = ALL_FW_X1 * ( - MEW_W )
ALL_FW_A1 = ALL_FW_M1 + ALL_FW_D1 + ALPHA_FIRST_ONLY
ALL_FW_D1 = DLY( ALL_FW_A1 )
ALL_ALPHA_PRE = DLY( ALL_FW_A1 )
ALL_ALPHA = ALL_ALPHA_PRE + ALPHA_FIRST_ONLY

OUTPUT = MAIN_OUT_H_N

#--------------------------------------
# MAIN
# MAIN OUTPUTS
MAIN_OUT_H_N = MAIN_M4
MAIN_OUT_H_B = MAIN_M5
MAIN_OUT_V   = MAIN_M6

# MAIN INPUTS
MAIN_ALPHA = ALL_ALPHA
MAIN_BETA  = ALL_BETA

# MAIN DESCRIPTION
MAIN_A1 = MAIN_IN + MAIN_M3
MAIN_M2 = MAIN_A1 * MAIN_ALPHA
MAIN_A2 = MAIN_A1 + ( - MAIN_D1 )
MAIN_M1 = MAIN_A2 * MAIN_BETA
MAIN_A3 = MAIN_A1 + MAIN_M1
MAIN_D1 = DLY( MAIN_A3 )
MAIN_A4 = MAIN_D1 + MAIN_M1
MAIN_D2 = DLY( MAIN_A4 )
MAIN_M3 = MAIN_D2 * ( - MAIN_ALPHA )
MAIN_A5 = MAIN_D2 + MAIN_M2
MAIN_A6 = MAIN_IN + MAIN_A5
MAIN_A7 = MAIN_IN + ( - MAIN_A5 )
MAIN_A8 = MAIN_A1 + MAIN_D2
MAIN_M4 = MAIN_A6 * 0.5
MAIN_M5 = MAIN_A7 * 0.5
MAIN_M6 = MAIN_A8 * 0.5

#--------------------------------------
# G(z)
# G(z) OUTPUTS
G_OUT = G_A3

# G(z) INPUTS
G_IN = MAIN_OUT_H_B
G_ALPHA = ALL_ALPHA
G_BETA  = ALL_BETA

# G(z) DESCRIPTION
G_A1 = G_IN + ( - G_A4 )
G_M1 = G_A1 * ( G_ALPHA )
G_A2 = G_M1 + G_IN
G_D1 = DLY( G_A2 )
G_A3 = G_D1 + G_M3
G_M2 = G_A3 * G_BETA
G_D2 = DLY( G_A3 )
G_M3 = G_D2 * ( - G_BETA )
G_A4 = G_D2 + G_M2

#--------------------------------------
# FW(z)
# FW(z) OUTPUTS
FW_OUT = FW_D2

# FW(z) INPUTS
FW_IN = MAIN_OUT_V
FW_ALPHA = ALL_ALPHA
FW_BETA  = ALL_BETA

# FW(z) DESCRIPTION
FW_A1 = FW_IN + FW_M2
FW_A2 = FW_A1 + ( - FW_D1 )
FW_M1 = FW_A2 * FW_BETA
FW_D1 = DLY( FW_M1 )
FW_A3 = FW_D1 + FW_M1
FW_D2 = DLY( FW_A3 )
FW_M2 = FW_D2 * FW_ALPHA

